﻿using System.Windows.Controls;
using PDF_Office.Model.Dialog.ToolsDialogs.SaftyDialogs;
using System.Windows;
using System;

namespace PDF_Office.Views.Dialog.ToolsDialogs.SaftyDialogs
{
    /// <summary>
    /// Interaction logic for SetPasswordDialog
    /// </summary>
    public partial class SetPasswordDialog : UserControl
    {
        Boolean PasswordHiddenHasFocus = false;
        Boolean PasswordDisplayHasFocus = false;
        public SetPasswordDialog()
        {
            InitializeComponent();
        }

        public PasswordBox PasswordHidden
        {
            get { return HidePasswordBox; }
            set { HidePasswordBox = value; }
        }

        public TextBox PasswordDisplay
        {
            get { return DisplayTextBox; }
            set { DisplayTextBox = value; }
        }

        private void DisplayEyeLabel_MouseLeftButtonUp(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            PasswordDisplay.Visibility = Visibility.Hidden;
            DisplayEyeLabel.Visibility = Visibility.Hidden;

            PasswordHidden.Visibility = Visibility.Visible;
            HideEyeLabel.Visibility = Visibility.Visible;
        }

        private void HideEyeLabel_MouseLeftButtonUp(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            PasswordDisplay.Visibility = Visibility.Visible;
            DisplayEyeLabel.Visibility = Visibility.Visible;

            PasswordHidden.Visibility = Visibility.Hidden;
            HideEyeLabel.Visibility = Visibility.Hidden;
        }

        private void HidePasswordBox_GotFocus(object sender, RoutedEventArgs e)
        {
            PasswordHiddenHasFocus = true;
            PasswordDisplayHasFocus = false;
        }

        private void DisplayTextBox_GotFocus(object sender, RoutedEventArgs e)
        {
            PasswordHiddenHasFocus = false;
            PasswordDisplayHasFocus = true;
        }

        private void HidePasswordBox_PasswordChanged(object sender, RoutedEventArgs e)
        {
            if (PasswordDisplayHasFocus)
            { return; }
            PasswordDisplay.Text = PasswordHidden.Password;
            PasswordModel.UserPassword = PasswordHidden.Password;
        }

        private void DisplayTextBox_TextChanged(object sender, TextChangedEventArgs e)
        {
            if (PasswordHiddenHasFocus)
            { return; }
            PasswordHidden.Password= PasswordDisplay.Text;
            PasswordModel.UserPassword = PasswordDisplay.Text;
        }
    }
}
